package eu.mhsl.minecraft.WorldMuseum.worldSelector;

import eu.mhsl.minecraft.WorldMuseum.Main;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.event.player.PlayerJoinEvent;

public class WorldSelectListener implements Listener {
    @EventHandler
    public void onInteract(InventoryClickEvent event) {
        event.setCancelled(true);

        Main.instance().getWorlds().stream()
            .filter(viewableWorld -> viewableWorld.getItem().equals(event.getCurrentItem()))
            .findFirst()
            .ifPresent(viewableWorld -> viewableWorld.addViewer((Player) event.getWhoClicked()));
    }

    @EventHandler
    public void onJoin(PlayerJoinEvent event) {
        Bukkit.getScheduler().scheduleSyncDelayedTask(
            Main.instance(),
            () -> event.getPlayer().openInventory(
                WorldSelectInventory.generateInventory()
            )
        );
    }
}
