package eu.mhsl.minecraft.WorldMuseum.worldSelector;

import eu.mhsl.minecraft.WorldMuseum.Main;
import eu.mhsl.minecraft.WorldMuseum.ViewableWorld;
import org.bukkit.Bukkit;
import org.bukkit.inventory.Inventory;

import java.util.List;

public class WorldSelectInventory {
    public static Inventory generateInventory() {
        List<ViewableWorld> worlds = Main.instance().getWorlds();
        Inventory inventory = Bukkit.createInventory(null, Math.max(worlds.size() / 9, 1) * 9);

        worlds.stream()
            .filter(ViewableWorld::isEnabled)
            .forEach(viewableWorld -> inventory.addItem(viewableWorld.getItem()));

        return inventory;
    }
}
